diff --git a/mk/exec-env/windows/netuio/netuio.vcxproj b/mk/exec-env/windows/netuio/netuio.vcxproj
index 9e769b5d0..b6564e4e7 100644
--- a/mk/exec-env/windows/netuio/netuio.vcxproj
+++ b/mk/exec-env/windows/netuio/netuio.vcxproj
@@ -85,22 +85,22 @@
     <FilesToPackage Include="$(TargetPath)" />
   </ItemGroup>
   <ItemGroup>
-    <Inf Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio.inf" />
+    <Inf Include="..\..\..\..\kernel\windows\netuio\netuio.inf" />
   </ItemGroup>
   <ItemGroup>
-    <ResourceCompile Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio.rc" />
+    <ResourceCompile Include="..\..\..\..\kernel\windows\netuio\netuio.rc" />
   </ItemGroup>
   <ItemGroup>
-    <ClInclude Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio_dev.h" />
-    <ClInclude Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio_drv.h" />
-    <ClInclude Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio_interface.h" />
-    <ClInclude Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio_queue.h" />
-    <ClInclude Include="..\..\..\..\lib\librte_eal\windows\netuio\resource.h" />
+    <ClInclude Include="..\..\..\..\kernel\windows\netuio\netuio_dev.h" />
+    <ClInclude Include="..\..\..\..\kernel\windows\netuio\netuio_drv.h" />
+    <ClInclude Include="..\..\..\..\kernel\windows\netuio\netuio_interface.h" />
+    <ClInclude Include="..\..\..\..\kernel\windows\netuio\netuio_queue.h" />
+    <ClInclude Include="..\..\..\..\kernel\windows\netuio\resource.h" />
   </ItemGroup>
   <ItemGroup>
-    <ClCompile Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio_dev.c" />
-    <ClCompile Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio_drv.c" />
-    <ClCompile Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio_queue.c" />
+    <ClCompile Include="..\..\..\..\kernel\windows\netuio\netuio_dev.c" />
+    <ClCompile Include="..\..\..\..\kernel\windows\netuio\netuio_drv.c" />
+    <ClCompile Include="..\..\..\..\kernel\windows\netuio\netuio_queue.c" />
   </ItemGroup>
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.targets" />
   <ImportGroup Label="ExtensionTargets">
diff --git a/mk/exec-env/windows/netuio/netuio.vcxproj.filters b/mk/exec-env/windows/netuio/netuio.vcxproj.filters
index 72a397d7c..a21f9ad99 100644
--- a/mk/exec-env/windows/netuio/netuio.vcxproj.filters
+++ b/mk/exec-env/windows/netuio/netuio.vcxproj.filters
@@ -19,40 +19,40 @@
     </Filter>
   </ItemGroup>
   <ItemGroup>
-    <Inf Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio.inf">
+    <Inf Include="..\..\..\..\kernel\windows\netuio\netuio.inf">
       <Filter>Driver Files</Filter>
     </Inf>
   </ItemGroup>
   <ItemGroup>
-    <ResourceCompile Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio.rc">
+    <ResourceCompile Include="..\..\..\..\kernel\windows\netuio\netuio.rc">
       <Filter>Resource Files</Filter>
     </ResourceCompile>
   </ItemGroup>
   <ItemGroup>
-    <ClInclude Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio_interface.h">
+    <ClInclude Include="..\..\..\..\kernel\windows\netuio\netuio_interface.h">
       <Filter>Header Files</Filter>
     </ClInclude>
-    <ClInclude Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio_dev.h">
+    <ClInclude Include="..\..\..\..\kernel\windows\netuio\netuio_dev.h">
       <Filter>Header Files</Filter>
     </ClInclude>
-    <ClInclude Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio_drv.h">
+    <ClInclude Include="..\..\..\..\kernel\windows\netuio\netuio_drv.h">
       <Filter>Header Files</Filter>
     </ClInclude>
-    <ClInclude Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio_queue.h">
+    <ClInclude Include="..\..\..\..\kernel\windows\netuio\netuio_queue.h">
       <Filter>Header Files</Filter>
     </ClInclude>
-    <ClInclude Include="..\..\..\..\lib\librte_eal\windows\netuio\resource.h">
+    <ClInclude Include="..\..\..\..\kernel\windows\netuio\resource.h">
       <Filter>Header Files</Filter>
     </ClInclude>
   </ItemGroup>
   <ItemGroup>
-    <ClCompile Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio_queue.c">
+    <ClCompile Include="..\..\..\..\kernel\windows\netuio\netuio_queue.c">
       <Filter>Source Files</Filter>
     </ClCompile>
-    <ClCompile Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio_dev.c">
+    <ClCompile Include="..\..\..\..\kernel\windows\netuio\netuio_dev.c">
       <Filter>Source Files</Filter>
     </ClCompile>
-    <ClCompile Include="..\..\..\..\lib\librte_eal\windows\netuio\netuio_drv.c">
+    <ClCompile Include="..\..\..\..\kernel\windows\netuio\netuio_drv.c">
       <Filter>Source Files</Filter>
     </ClCompile>
   </ItemGroup>